=== debian/changelog ===
geographiclib (1.49-5) unstable; urgency=medium

  * Bump Standards-Version to 4.4.0, no changes.
  * Add Build-Depends-Package field to symbols file.
  * Remove package name from lintian overrides.
  * Update gbp.conf to use --source-only-changes by default.
  * Drop Python 2 support.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 22 Jul 2019 09:56:36 +0200

geographiclib (1.49-4) unstable; urgency=medium

  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.
  * Strip trailing whitespace from changelog.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 31 Jul 2018 16:05:44 +0200

geographiclib (1.49-3) unstable; urgency=medium

  [ Francesco Paolo Lovergine ]
  * Doxygen JQuery is not compatible with the standard one, so the embedded
    version is now preserved.
  * Now using treeview in doxygen doc for a better readability.
  * Fixed Mathjax path for doxygen use.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.1.5, no changes.
  * Update copyright-format URL to use HTTPS.
  * Update Vcs-* URLs for Salsa.
  * Drop ancient X-Python-version field.
  * Strip trailing whitespace from control & rules files.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Jul 2018 16:19:38 +0200

geographiclib (1.49-2) unstable; urgency=medium

  * Add patch by Chris Lamb to make the build reproducible.
    (closes: #878708)
  * Strip trailing whitespace from changelog & control files.
  * Drop obsolete dbg package.
  * Mark libgeographic17 as Multi-Arch: same.
  * Bump Standards-Version to 4.1.2, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 26 Dec 2017 19:39:16 +0100

geographiclib (1.49-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 07 Oct 2017 10:27:17 +0200

geographiclib (1.49-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Change priority for libgeographic-dbg from extra to optional.
  * Bump Standards-Version to 4.1.1, changes: priority.
  * Use pkg-info.mk variables instead of dpkg-parsechangelog output.
  * Add autopkgtest to test installability.
  * Refresh patches.
  * Add lintian overrides for privacy-breach-generic.
  * Change node-geographiclib section to javascript.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 Oct 2017 14:05:40 +0200
